function sift_arr = normalize_sift(sift_arr)
% normalize SIFT descriptors (after Lowe)

% first rescale to unit length
tmp = sqrt(sum(sift_arr.^2, 2));
tmp(find(tmp < eps)) = 1;
sift_arr = sift_arr ./ repmat(tmp, [1 size(sift_arr,2)]);

% suppress large gradients
sift_arr(find(sift_arr > 0.2)) = 0.2;

% finally, normalize to zero mean and unit length
sift_arr = normalize_rows(sift_arr);