% show circles in output_dir

clear;

% parameters
global sigma_init sigma_final sigma_iters sigma_factor sigma_final_factor % for build_pyramid
global nonmax_width max_points border_width laplacian_thresh % for find_maxima
global sigma_diff max_aspect_ratio % for affine_adaptation

% set paths for input and output
input_dir = 'input'; % top-level image input directory
working_dir_list = {'dir1'; 'dir2'}; % subdirectories of input_dir to process
image_extension = 'bmp';
output_dir = 'output'; % directory to save output of feature extraction



for d = 1:size(working_dir_list,1)
    
    working_dir = working_dir_list{d};
    files = dir(sprintf('%s/%s/*.%s', input_dir, working_dir, image_extension));
    nfiles = size(files,1);
    
    for i = 1:nfiles
        
	fname = files(i).name;
	base_fname = fname(1:size(fname,2)-4);
	image_fname = sprintf('%s/%s/%s', input_dir, working_dir, fname);
	fprintf('\nLoading %s\n', fname);
		
    I = load_image(image_fname);
        
        % load circles
	in_fname = sprintf('%s/%s/%s_circles.txt', output_dir, working_dir, base_fname);
        if ~isempty(in_fname)
            circles = load(in_fname, '-ascii');
      	    show_all_circles(I, circles);
     	    pause;
        end        
    end	
end