function I_out = filter_point(F, I, cx, cy)

    %fprintf('filter_point\n');
    f_wid = floor((size(F,2) - 1) / 2);
    f_hgt = floor((size(F,1) - 1) / 2);
    
    x_lo = cx - f_wid;
    x_hi = cx + f_wid;
    y_lo = cy - f_hgt;
    y_hi = cy + f_hgt;
    
    % the reason for using interp2 is to deal with out-of-boundaries coordinates
%    [grid_x, grid_y] = meshgrid(x_lo:x_hi, y_lo:y_hi);
%    I_data = interp2(I, grid_x, grid_y);
%    I_data(find(isnan(I_data))) = 0;
    
    x_lo_f = 1;
    x_hi_f = size(F,2);
    y_lo_f = 1;
    y_hi_f = size(F,1);
    I_data = zeros(size(F));
    
    if x_lo < 1
        x_lo_f = 2 - x_lo;
        x_lo = 1;
    end
    if x_hi > size(I,2)
        x_hi_f = size(F,2) - x_hi + size(I,2);
        x_hi = size(I,2);
    end
    if y_lo < 1
        y_lo_f = 2 - y_lo;
        y_lo = 1;
    end
    if y_hi > size(I,1)
        y_hi_f = size(F,1) - y_hi + size(I,1);
        y_hi = size(I,1);
    end
    
    I_data(y_lo_f:y_hi_f, x_lo_f:x_hi_f) = I(y_lo:y_hi, x_lo:x_hi);
    I_out = sum(sum(I_data .* F));
