function I = load_image(image_fname)

I = imread(image_fname);
if ndims(I) > 2 % not(isgray(I))
    I = rgb2gray(I);
end
% I = histeq(I); % histogram equalization
I = im2double(I); % all values are in range [0,1]

% resize if too large
[hgt wid] = size(I);

max_size = 1000;

if max(hgt,wid) > max_size
    fprintf('\nLoad_image: %s: warning: resizing image!\n\n', image_fname);
    if hgt > wid
        new_hgt = max_size;
        new_wid = round(wid * (max_size/hgt));
    else
        new_wid = max_size;
        new_hgt = round(hgt * (max_size/wid));
    end

    I = imresize(I, [new_hgt new_wid], 'bicubic');
end
