function N=nonmax_suppress(M, filt_wid)
% M is a 3D array
% filt_wid must be odd

[hgt wid dep] = size(M);
middle = floor(filt_wid/2);
N=zeros(size(M));

% in each 'slice', replace each value by maximum in its window
fprintf('Filtering slices\n');
for d=1:dep
    fprintf('Slice %d\n', d);
    N(:,:,d)=colfilt(M(:,:,d), [filt_wid, filt_wid], 'sliding', @max);
end

% perform max filtering in the third dimension
NP = permute(N, [3 1 2]);
NP = reshape(NP, [dep wid*hgt]);
NP = colfilt(NP, [filt_wid 1], 'sliding', @max);

NP = reshape(NP, [dep hgt wid]);
NP = permute(NP, [2 3 1]);

N = NP - M;
N(find(N==0)) = -1;
N(find(N>0)) = 0;
N = N * -1;

