#! /bin/bash

# this script runs a list of n of tasks on a list of machines
# assuming the home dir of the user is accessible on that machine

n=10
machines="kent oswald hydrus"
task=./task.sh


# prepare the lock file
prefix=/tmp/task_lock.$$ # some non-existing name
rm -f $prefix*
touch $prefix.0

trap 'kill -HUP 0' 0 # handle exit gracefully
for machine in $machines; do
  for((i=0; i<n; i++)); do
     # atomic operation: mv, if succeeds, it means that task #i is available
     if mv $prefix.$i $prefix.$[i+1] 2> /dev/null; then
       # ssh to the machine and run the task
       ssh $machine "cd $PWD; $task $i"
     fi
  done &
done

wait

